﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public class SpawnTrolls : NetworkBehaviour
{

    public GameObject targetPrefab;  // spawnolt prefab
    public float minSpawn = 2;  // minimális idő 2 spawn között
    public float maxSpawn = 5;  // maximális idő 2 spawn között

    bool canSpawn = true;  // jöhet-e a következő ellenség

    void Update()
    {
        if (!isServer) return;  // enélkül akkor is spawnol, ha nem fut a szerver (de a program igen)
        if (!canSpawn) return;  // még nem telt el megfelelő idő
        float nextSpawn = Random.Range(minSpawn, maxSpawn);
        Invoke("Spawn", nextSpawn);  // nextSpawn idő múlva meghívjuk a Spawn függvényt
        canSpawn = false;
    }

    void Spawn()
    {
        if (targetPrefab == null)
        {
            canSpawn = true;
            return;
        }
        // lekérjük a gyerek objektumok Transform komponenseit, ezek közül választunk random
        Transform[] spawnLocations = gameObject.GetComponentsInChildren<Transform>();
        int spawnIdx = Random.Range(0, spawnLocations.Length);
        GameObject newObject = (GameObject)Instantiate(targetPrefab,
                                                        spawnLocations[spawnIdx].position, spawnLocations[spawnIdx].rotation);
        NetworkServer.Spawn(newObject); // spawn-t hívunk a szerveren, így minden klienshez eljut az új objektum
        canSpawn = true;
    }
}

